/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <windows.h>



#define VER         "0.3"
#define BUFFSZ      256
#define SOF1        1
#define SOF2        2

typedef unsigned char   u_char;
typedef unsigned int    u_int;



void sofregkey(LPCTSTR lpSubKey, char *name, int softype);
u_int get_serial(void);
u_int rnd(u_int num);
void sof_violence_pwd(u_int enc, u_char *data, int len);
void sof2_violence_pwd(u_int enc, u_char *data, int len);



u_int   serial;



int main(void) {
    setbuf(stdout, NULL);

    fputs("\n"
        "Soldier of Fortune 1 and 2 violence password decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    serial = get_serial();
    printf("  remember that this tool works only on the same computer of the game\n\n");

    sofregkey("Software\\Raven Software\\SoF",          "Server", SOF1);
    sofregkey("Software\\Raven Software\\SoF DEMO",     "Server", SOF1);
    sofregkey("Software\\Raven Software\\SoF2",         "ICARUS", SOF2);
    sofregkey("Software\\Raven Software\\SoF2 DEMO",    "ICARUS", SOF2);

    printf("\n  Press RETURN to exit\n");
    fgetc(stdin);
    return(0);
}



void sofregkey(LPCTSTR lpSubKey, char *name, int softype) {
    HKEY    key;
    int     len;
    u_char  buff[BUFFSZ + 1];

    if(RegOpenKeyEx(HKEY_CURRENT_USER, lpSubKey, 0, KEY_READ, &key)) {
        if(RegOpenKeyEx(HKEY_USERS, lpSubKey, 0, KEY_READ, &key)) {
            goto quit;
        }
    }
    len = BUFFSZ;
    if(RegQueryValueEx(key, name, NULL, NULL, buff, (void *)&len)) {
        RegCloseKey(key);
        return;
    }
    if(softype == SOF1) {
        sof_violence_pwd(serial, buff, len);
    } else if(softype == SOF2) {
        sof2_violence_pwd(serial, buff, len);
    }

    printf("    Password (%s):\t%s\n", strrchr(lpSubKey, '\\') + 1, buff);

quit:
    RegCloseKey(key);
}



u_int get_serial(void) {
    DWORD   lpVolumeSerialNumber,
            lpMaximumComponentLength,
            lpFileSystemFlags;
    int     i,
            drives;
    char    lpVolumeNameBuffer[MAX_PATH + 1],
            lpFileSystemNameBuffer[MAX_PATH + 1],
            drive[4];

    drives = GetLogicalDrives();

    for(i = 0; i < drives; i++) {
        sprintf(drive, "%c:\\", 'A' + i);

        if(GetDriveType(drive) != DRIVE_FIXED) continue;

        if(GetVolumeInformation(
            drive,
            lpVolumeNameBuffer,
            MAX_PATH,
            &lpVolumeSerialNumber,
            &lpMaximumComponentLength,
            &lpFileSystemFlags,
            lpFileSystemNameBuffer,
            MAX_PATH)) break;
    }
    if(i == drives) {
        printf("\nError: no fixed drives found on this computer, it's not possible to continue\n");
        printf("\n  Press RETURN to exit\n");
        fgetc(stdin);
        exit(1);
    }
    printf("  %s volume serial number: 0x%08x\n", drive, (u_int)lpVolumeSerialNumber);
    return(lpVolumeSerialNumber);
}



u_int rnd(u_int num) {
    return((num * 0x343FD) + 0x269EC3);
}



void sof_violence_pwd(u_int enc, u_char *data, int len) {
    int     i;

    for(i = 0; i < 24; i++) {
        enc = rnd(enc);
    }

    if(len < 4) {
        data[0] = 0;
        return;
    }
    sof2_violence_pwd(enc, data, len - 4);
}



void sof2_violence_pwd(u_int enc, u_char *data, int len) {
    int     i;

    enc = rnd(enc);
    enc = ((enc >> 16) & 0xffff) | (rnd(enc) & 0xffff0000);

    for(i = 0; i < len; i++) {
        data[i] -= (enc >> ((i & 7) << 3)) & 0xff;
    }
}


